#include <iostream>
#include <cstdlib>
#include <queue>
#include <map>
#include <time.h>

struct Elemente {
	int priority;
	int seq;
	unsigned num;

	Elemente(int p, int s)
		: priority(p), seq(s)
	{
		static unsigned number = 0;
		num = ++number;
	}

	bool operator < (const Elemente& e) const
	{
		if (priority == e.priority)
			return num > e.num;
		else
			return priority < e.priority;
	}
};

int main()
{
	std::srand(time(NULL));
	std::priority_queue<Elemente> pq;
	std::map<int, int> seqs;
	int seq = 0;
	for (int i = 1; i < 1000; ++i)
	{
		pq.push(Elemente(rand() % 20, ++seq));
	}

	while (! pq.empty())
	{
		Elemente e = pq.top();
		pq.pop();
		std::map<int, int>::iterator it = seqs.find(e.priority);
		if (it != seqs.end()) {
			if (it->second > e.seq) std::cout << "Sequence error! ";
		}
		seqs[e.priority] = e.seq;
		std::cout << "Found: priority " << e.priority << ", seq " << e.seq << std::endl;
	}
}
